module Workarea
  module Storefront
    module ContentBlocks
      class YoutubePlaylistsViewModel < ContentBlockViewModel
        # Custom local variables passed into the view template.
        #
        # @return [Hash]
        def locals
          super.merge(type: 'Youtube Playlists')
        end

        def lists
          id_list = data[:lists].reject { |e| e.to_s.empty? }
          get_list_data({:id => id_list.join(",")})
          @all_playlists["items"].each do |playlist|
            playlist["video"]=  get_video_data(playlist["id"], {maxResults: 3})
          end
          @all_playlists
        end

        private

        def get_video_data(id, overrides)
          response = JSON.parse(YoutubePlaylists.get_video_data(id, overrides).read)
        end

        def get_list_data(overrides)
          @all_playlists ||= JSON.parse(YoutubePlaylists.get_list_data(overrides).read)
        end
        # TODO: Add more custom view model logic.
      end
    end
  end
end
