require 'workarea'
require 'workarea/youtube_playlists/engine'
require 'workarea/youtube_playlists/version'
require 'open-uri'

module Workarea
  module YoutubePlaylists
    def self.get_list_data(overrides)
      base_url  = Workarea.config.youtube_base_url
      options   = params
      options   = options.merge(overrides || {}) 
      options[:channelId] = Workarea.config.youtube_channel_id unless options[:id].present?

      end_point = "#{base_url}/playlists?#{options.to_param}" 
      open(end_point)
    end
    
    def self.get_video_data(playlist_id, overrides)
      base_url  = Workarea.config.youtube_base_url
      options   = params
      options[:playlistId] = playlist_id
      options = options.merge(overrides || {}) 
      end_point = "#{base_url}/playlistItems?#{options.to_param}" 
      open(end_point)
    end

    def self.params
      params = Workarea.config.youtube_options
      params[:key] = Workarea.config.youtube_api_key
      return params
    end
  end
end
